/*
 * 		YAV (Yet another Visualiser)
 * 		(c) 2004 by Robin Quast
 *		Version 1.0 (04.03.2004)
 *		
 *  erstellt im Rahmen der Diplomarbeit
 * "Theorie und Java- Realisierung
 *  ausgewhlter Algorithmen zur
 *  Bestimmung krzester Wege in Graphen"
 *
 *  betreut durch Prof. Dr. Lenze
 *  an der Fachhochschule Dortmund
 *  im SS 2003/ WS 2003/2004
 *
 *	@(#)AdjazenzmatrixTable.java	1.0 04/03/09
 */

import javax.swing.*;
import java.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Enumeration;
import java.lang.Math;
import java.util.Collections;
import java.awt.geom.*;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.*;
import javax.swing.event.*;

/** Diese Klasse reprsentiert die Adjazenzmatrix als JTable.
 * Die Inhalte sind in Verbindung mit dem AdjazenzmatrixTableModel 
 * zu benutzen und auf Grund der Implementation des Models nicht editierbar.
 */
class AdjazenzmatrixTable
extends JTable  {

	/** Konstruktor, der das bergebene Model setzt und default-
	 * Einstellungen fr die JTable vornimmt.
	 */
	public AdjazenzmatrixTable(AbstractTableModel atm) {
        super();	
		setModel(atm);
     	setPreferences();
	}

	/** Konstruktor, der das bergebene Model setzt und default-
	 * Einstellungen fr die JTable vornimmt. Zustzlich kann hier noch ein
	 * DefaultTableColumnModel bergeben werden.
	 */
	public AdjazenzmatrixTable(AbstractTableModel atm,DefaultTableColumnModel acm) {
        super();	
		setModel(atm);
		setColumnModel(acm); 
     	setPreferences();
	}

	/** Konstruktor, der als Model eine Instanz von  AdjazenzmatrixTableModel
	 * setzt.
	 */
	public AdjazenzmatrixTable() {
		super();
		setModel(new AdjazenzmatrixTableModel());
		setPreferences();
	}

	/** Diese Methode setzt default Einstellungen fr die JTable. Dies 
	 * wren im einzelnen:<br>
	 *	setPreferredScrollableViewportSize(new Dimension(150, 200));<br>
	 *  getTableHeader().setReorderingAllowed(false);<br>
	 *  setShowGrid(true);<br>
	 *	setSelectionMode(0);<br>
	 *	setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
	 */	
	public void setPreferences() {
		setPreferredScrollableViewportSize(new Dimension(150, 200));
		getTableHeader().setReorderingAllowed(false);
		setShowGrid(true);
		setSelectionMode(0);
		setAutoResizeMode(JTable.AUTO_RESIZE_OFF); 
	}

}