/*
 * 		YAV (Yet another Visualiser)
 * 		(c) 2004 by Robin Quast
 *		Version 1.0 (04.03.2004)
 *		
 *  erstellt im Rahmen der Diplomarbeit
 * "Theorie und Java- Realisierung
 *  ausgewhlter Algorithmen zur
 *  Bestimmung krzester Wege in Graphen"
 *
 *  betreut durch Prof. Dr. Lenze
 *  an der Fachhochschule Dortmund
 *  im SS 2003/ WS 2003/2004
 *
 *	@(#)DijkstraEdgeTableModel.java	1.0 04/03/09
 */

import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;
import java.util.Vector;
import java.util.Collections;

/** Die DijkstraEdgeTableModel Klasse stellt das Datenmodel fr die Kantenliste 
 * in der JTable dar. Sie ist von EdgeTableModel abgeleitet mit dem unterschied, 
 * dass die addRow Routine berschrieben wird.
 */
class DijkstraEdgeTableModel 
extends EdgeTableModel {

	/** Hinzufgen einer Zeile. 
	 */
	public void addRow(Edge edge) {
		if (!data.contains(edge)) {
			data.add(0,edge);
		}
		fireTableRowsInserted(0,data.size()-1) ;
	}
	
	/** Diese Methode gibt immer false zurck, da keine Zelle 
	 * editierbar ist.
	 */	
   	public boolean isCellEditable(int row, int col) {
        return false;
   	}
}